"use strict";
/**
 * @copyright   2017-2018, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Combine app and plugin names into a Node/NPM applicable module name.
 */
function formatModuleName(appName, addonName, name, scoped) {
    if (scoped === void 0) { scoped = false; }
    var moduleName = name
        .toLowerCase()
        .replace('plugin:', '')
        .replace(addonName + ":", '');
    if (scoped) {
        return "@" + appName + "/" + addonName + "-" + moduleName;
    }
    return appName + "-" + addonName + "-" + moduleName;
}
exports.default = formatModuleName;
