/**
 * @copyright   2017-2018, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
import Reporter from '../Reporter';
import { RoutineInterface } from '../Routine';
import { TaskInterface } from '../Task';
export interface Line {
    depth: number;
    routine: RoutineInterface;
    tasks: TaskInterface[];
}
export default class DefaultReporter extends Reporter<Line> {
    depth: number;
    keyLength: number;
    bootstrap(): void;
    /**
     * Calculate the max string length for routine key's at every depth.
     */
    calculateKeyLength(routines: RoutineInterface[], depth?: number): number;
    /**
     * Calculate the current number of tasks that have completed.
     */
    calculateTaskCompletion(tasks: TaskInterface[]): number;
    /**
     * Return the task title with additional metadata.
     */
    getLineTitle(task: TaskInterface | RoutineInterface, usedColumns?: number): string;
    handleStart: (routines: RoutineInterface[]) => void;
    handleCommand: () => void;
    handleTask: (task: TaskInterface, routine: RoutineInterface) => void;
    handleTaskComplete: (task: TaskInterface, routine: RoutineInterface) => void;
    handleRender: () => void;
    handleRoutine: (routine: RoutineInterface, value: any, wasParallel: boolean) => void;
    handleRoutineComplete: (routine: RoutineInterface, result: any, wasParallel: boolean) => void;
    renderLine(routine: RoutineInterface, task: TaskInterface | null, depth: number): void;
}
