/**
 * @copyright   2017-2018, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 */
import debug from 'debug';
import { Struct } from 'optimal';
import { PluginInterface } from './Plugin';
import { ReporterInterface } from './Reporter';
export interface Debugger extends debug.IDebugger {
    (message: any, ...args: any[]): void;
    invariant(condition: boolean, message: string, pass: string, fail: string): void;
}
export interface PluginConfig {
    plugin: string;
    [key: string]: any;
}
export interface ReporterConfig {
    reporter: string;
    [key: string]: any;
}
export interface ToolConfig extends Struct {
    debug: boolean;
    extends: string | string[];
    plugins: (string | PluginConfig | PluginInterface)[];
    reporters: (string | ReporterConfig | ReporterInterface)[];
    [key: string]: any;
}
export interface PackageConfig extends Struct {
    name: string;
}
export declare type Status = 'pending' | 'running' | 'skipped' | 'passed' | 'failed';
export declare type Color = 'black' | 'red' | 'green' | 'yellow' | 'blue' | 'magenta' | 'cyan' | 'white' | 'gray';
export declare type ColorType = 'failure' | 'pending' | 'success' | 'warning';
export declare type ColorPalette = {
    [T in ColorType]: Color | string;
};
